package com.siwei.recyclebox.rs485;

import android.content.Context;
import android.util.Log;

import com.siwei.recyclebox.deviceUtils.ByteUtil;

import java.io.IOException;

import tp.xmaihh.serialport.SerialHelper;
import tp.xmaihh.serialport.bean.ComBean;

/**
 * *************
 * 项目名称ai-garbage-box18
 * com.siwei.recyclebox.rs485
 * 2020/12/1015:45
 */
public class ComUltrasonic {

    private static ComUltrasonic instance;
    private SerialHelper mHelper;
    boolean receivingData = false;    //接收数据
    private byte[] readArray;    //接收数据的数组
    /**
     *     * 超声波的配置
     *     * 厂家 电应普
     *     * baudRate: 波特率    9600
     *     * dataBits: 数据位    8         UsbSerialPort.DATABITS_8
     *     * stopBits: 停止位    1         UsbSerialPort.STOPBITS_1
     *     * parity:   校验位    无校验    UsbSerialPort.PARITY_NONE
     *     * vendorId: 供应商ID  6790
     *     * onDataReceived:  接口提供的数据监听,不知道怎么用
     *    
     */
    private final String TAG = "COM口";
    public static String port = "";
    private static final int btl = 9600;//波特率
    private static final int jyw = 0;//无校验
    private static final int sjw = 8;//校验位
    private static final int tzw = 1;//停止位
    private static final int lk = 0;//流控

    /**
     * 单例模式
     *
     * @return
     * @author ltb
     * @date 2020/12/08 18:02
     */
    public static ComUltrasonic getInstance() {
        if (instance == null) {
            instance = new ComUltrasonic();
        }
        return instance;
    }


    /**
     * 连接称并配置
     *
     * @return
     * @author ltb
     * @date 2020/12/08 18:18
     */
    public void init() {
        //实例化SerialHelper对象，放入串口号和波特率
        mHelper = new SerialHelper(port, btl) {
            //监听传回数据
            @Override
            protected void onDataReceived(ComBean paramComBean) {
                if (receivingData) {
                    readArray = paramComBean.bRec;
                }
            }
        };
        //开始连接串口
        try {
            mHelper.setPort(port);
            mHelper.setBaudRate(btl);
            mHelper.setStopBits(tzw);  //设置停止位
            mHelper.setDataBits(sjw);  //设置数据位
            mHelper.setParity(jyw);      //设置校验位
            mHelper.setFlowCon(lk);    //设置流控
            mHelper.open();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public int readDistance() {
        Log.i(TAG, "readDistance: 给" + port + "发信息");
        mHelper.sendHex("0103010200012436");//发送指令
        //发送数据后开始可以执行监听
        receivingData = true;
        int bytes1 = 0;
        //堵塞监听
        for (int times = 0; times < 10; times++) {
            try {
                Thread.sleep(500);
            } catch (InterruptedException e) {
                e.printStackTrace();
                bytes1 = -4;
                Log.d(TAG, "readDistance: 不是吧阿sir,休眠也能报错");
            }
            if (readArray != null) {
                //用bytes接收数据
                Log.i(TAG, "readDistance: " + ByteUtil.bytesToString(readArray));
                Log.i(TAG, "readDistance: 校验码" + ByteUtil.getCRC(readArray));
                if (readArray[1] == 3 && ByteUtil.getCRC(readArray) == 0 && readArray[0] == 1) {
                    byte[] weightBytes = new byte[4];
                    weightBytes[2] = readArray[3];
                    weightBytes[3] = readArray[4];
                    bytes1 = ByteUtil.bytes2Int(weightBytes);
                    Log.i(TAG, "readDistance: 读到了，距离为" + bytes1);
                    readArray = null;
                    receivingData = false;

                    return bytes1;

                } else {
                    mHelper.sendHex("0103010200012436");//发送指令
                    bytes1 = -3;
                    Log.i(TAG, "readWeight: 数据验证错误,重新发送");
                    readArray = null;
                    continue;
                }
            } else {
                mHelper.sendHex("0103010200012436");//发送指令
                bytes1 = -3;
                Log.i(TAG, "readWeight: 收不到数据,重新发送");
            }
        }


        readArray = null;
        receivingData = false;
        return bytes1;
//
//        mHelper.sendHex("0103010200012436");//发送指令
//        //发送数据后开始可以执行监听
//        receivingData = true;
//        int bytes1 = 0;
//
//        while (true) {
//            //堵塞监听
//            for (int times = 0; times < 2; times++) {
//                mHelper.sendHex("0103010200012436");//发送指令
//                try {
//                    Thread.sleep(200);
//                } catch (InterruptedException e) {
//                    e.printStackTrace();
//                    bytes1 = -4;
//                    Log.d(TAG, "readDistance: 不是吧阿sir,休眠也能报错");
//                }
//                Log.d(TAG, port + "    readDistance: 第" + times + "次查询");
//                if (readArray != null) {
//                    //用bytes接收数据
//                    Log.i(TAG, "readDistance: " + ByteUtil.bytesToString(readArray));
//                    Log.i(TAG, "readDistance: 校验码" + ByteUtil.getCRC(readArray));
//                    if (readArray[1] == 3 && ByteUtil.getCRC(readArray) == 0) {
//                        byte[] weightBytes = new byte[4];
//                        weightBytes[2] = readArray[3];
//                        weightBytes[3] = readArray[4];
//
//                            bytes1 = ByteUtil.bytes2Int(weightBytes);
//                            Log.i(TAG, "readDistance: 读到了，距离为" + bytes1);
//                        readArray = null;
//                        receivingData = false;
//                            return bytes1;
//
//                    }
//                }
//            }
//            break;
//        }
//        readArray = null;
//        receivingData = false;
//        return -3;

    }


    /**
     * 关闭端口,必须要关闭串口状态下
     *
     * @return
     * @author ltb
     * @date 2020/12/09 13:20
     */
    public void close() {
        if (mHelper.isOpen()) {
            mHelper.close();
        }
    }

}
