package com.siwei.recyclebox.rs485;

import android.content.Context;
import android.databinding.ObservableField;
import android.util.Log;
import android.widget.TextView;
import android.widget.Toast;

/**
 * 控制Rs485类运行
 * *************
 * 项目名称ai-garbage-box18
 * com.siwei.recyclebox.rs485
 * 2020/12/0910:31
 */
public class Control extends Thread {
    private String TAG = "COM口";
    private static ObservableField text;
    public static String[] port = new String[]{"/dev/ttyS4","/dev/ttymxc0", "/dev/ttymxc1", "/dev/ttymxc2", "/dev/ttymxc3"};
//    public static String[] port = new String[]{"/dev/ttyS0", "/dev/ttyS1"};
    public static String foundPort = "";

    public Control(ObservableField text) {
        this.text = text;
    }

    /**
     * @param * @param null
     * @return
     * @method
     * @description 开启线程读取数据, 循环给串口发消息，找到回复的串口就保存（一个）
     * @date: 2020/12/09 15:02
     * @author: ltb
     */
    @Override
    public void run() {
        /**
         * 称的状态
         * -3  没收到数据/异常报错
         * -2  收到的数据不是称的
         * -1  称读数超重,可能是接触不良
         * */
        for (int x=0;x<=port.length;x++) {
            Log.i(TAG, "checkPort: 设置端口" + port[x]);
            ComWeight.getInstance().port = port[x];//设置端口
            Log.i(TAG, "checkPort: 打开端串口" + ComWeight.getInstance().port);
            ComWeight.getInstance().init();//打开串口
            int a = -2;
            a = ComWeight.getInstance().readWeight();
            Log.i(TAG, "run: 读到了"+ a);
            ComWeight.getInstance().close();
            if (a > -2) {
                Log.i(TAG, "checkPort: 找到" + port[x]);
                foundPort = port[x];
                break ;
            }

        }
        switch (foundPort) {
            case "/dev/ttymxc0":
                text.set("COM1");
                break;
            case "/dev/ttymxc1":
                text.set("COM2");
                break;
            case "/dev/ttymxc2":
                text.set("COM3");
                break;
            case "/dev/ttymxc3":
                text.set("COM4");
                break;
            case "/dev/ttyS4":
                text.set("侧边绿口");
                break;
            default:
                text.set("没找到，正在重新查找，请检查是否接触不良");
        }

    }


}
